from server import *
import threading
import sched
from time import sleep

scheduler = sched.scheduler()
def run_scheduler():
	sleep(1) # UWSGI does weird things on startup
	while True:
		scheduler.run()
		sleep(10)

def sched_func(delay, priority=0, firstdelay=None, args=[], kargs={}):
	if firstdelay == None:
		firstdelay = random.randint(1, 120)
	def wrapper(func):
		def sched_wrapper():
			with app.test_request_context():
				try:
					func(*args, **kargs)
				except Exception:
					traceback.print_exc()
			scheduler.enter(delay, priority, sched_wrapper)
		scheduler.enter(firstdelay, priority, sched_wrapper)
		return func
	return wrapper

threading.Thread(target=run_scheduler, daemon=True).start()
